/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmzettel.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class StimmzettelKopfdatumUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String schluessel;

    public java.lang.String getSchluessel(){
      return schluessel;
    }

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietUK getGebietUK(){
      return gebietUK;
    }
  protected final de.ivu.elect.business.gruppe.entity.GruppeUK gruppeUK;

    public de.ivu.elect.business.gruppe.entity.GruppeUK getGruppeUK(){
      return gruppeUK;
    }

  public StimmzettelKopfdatumUK(
java.lang.String schluessel
,   de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK
,   de.ivu.elect.business.gruppe.entity.GruppeUK gruppeUK
  ) {
    super();


      this.schluessel = schluessel;
        this.gebietUK = gebietUK;
      this.gruppeUK = gruppeUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((schluessel == null) ? 0 : schluessel.hashCode());
        
                    result = result + ((gebietUK == null) ? 0 : gebietUK.hashCode());
                    result = result + ((gruppeUK == null) ? 0 : gruppeUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            StimmzettelKopfdatumUK other = (StimmzettelKopfdatumUK) obj;

                if (schluessel == null) {
          if (other.schluessel != null) {
            return false;
          }
        } else if (!schluessel.equals(other.schluessel)) {
          return false;
        }
        
                if (gebietUK == null) {
          if (other.gebietUK != null) {
            return false;
          }
        } else if (!gebietUK.equals(other.gebietUK)) {
          return false;
        }
                if (gruppeUK == null) {
          if (other.gruppeUK != null) {
            return false;
          }
        } else if (!gruppeUK.equals(other.gruppeUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return StimmzettelKopfdatumConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietUK.getAllEntityFieldValues());
    result.addAll(gruppeUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmzettelKopfdatumConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmzettelKopfdatumConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, schluessel));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "StimmzettelKopfdatumUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"schluessel="+schluessel
                                        +", "                +"gebietUK="+gebietUK
                            +", "                +"gruppeUK="+gruppeUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(schluessel);
     return list;
   }

            public static <E extends StimmzettelKopfdatum> java.util.Map<StimmzettelKopfdatumUK, E> mappeStimmzettelKopfdatumNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(StimmzettelKopfdatum::getStimmzettelKopfdatumUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<StimmzettelKopfdatum, StimmzettelKopfdatumUK> getStimmzettelKopfdatumToUKFunction() {
                return StimmzettelKopfdatum::getStimmzettelKopfdatumUK;
                }

}
